(**********************************************************************
*                                                                     *
*               ᮢ, ,  뢠             *
*                                                                     *
**********************************************************************)
                              unit Demo_Un3;

                                interface

uses Dos, Objects, Views, App, Figaro;
{}
type

  PHzView = ^THzView;
  THzView = object(TView)
    _Hz   : longint;
    _Text : string[15];
    constructor Init(var Bounds: TRect; const Text : string);
    procedure Draw; virtual;
    procedure Update (Hz : longint);
  end;

  PHeapView = ^THeapView;
  THeapView = object(TView)
    procedure Draw; virtual;
    procedure Update;
  end;

  PClockView = ^TClockView;
  TClockView = object(TView)
    StartTime, OldTime : longint;
    LastTime  : DateTime;
    TimeStr   : string[10];
    constructor Init(var Bounds: TRect);
    procedure Draw; virtual;
    function FormatTimeStr(H, M, S: Word): String; virtual;
    procedure Update; virtual;
  end;

{}
                              implementation
{}

uses Drivers;
{
       ķ
                                THzView                         
       Ľ
}
constructor THzView.Init(var Bounds: TRect; const Text: string);
begin
  inherited Init(Bounds);
  _Hz  := 0;
  _Text:= Text;
end;

procedure THzView.Draw;
var
  S,T: String;
  B: TDrawBuffer;
  C: Byte;
begin
  Str(_Hz:6, S);
  S:= #179+_Text +S+ ' Hz';
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, S, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

procedure THzView.Update (Hz : longint);
begin
  _Hz:= Hz;
  DrawView;
end;
{
       ķ
                                THeapView                       
       Ľ
}
procedure THeapView.Draw;
var
  S,T: String;
  B: TDrawBuffer;
  C: Byte;
begin
  Str(MemAvail:7, S);
  Str(MaxAvail:7, T);
  S:= #179' Mem='+S+'  Max='+T;
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, S, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

procedure THeapView.Update;
begin
   DrawView;
end;
{
       ķ
                               TClockView                       
       Ľ
}
function LeadingZero(w: Word): String;
var s: String;
begin
  Str(w:0, s);
  LeadingZero := Copy('00', 1, 2 - Length(s)) + s;
end;

constructor TClockView.Init(var Bounds: TRect);
begin
  TView.Init(Bounds);
  FillChar(LastTime, SizeOf(LastTime), #$FF);
  StartTime:= Figaro.Get_StartTime;
  OldTime  := 0;
  TimeStr  := '';
end;

procedure TClockView.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  MoveStr(B, TimeStr, C);
  WriteLine(0, 0, Size.X, 1, B);
end;

procedure TClockView.Update;
var  h,m,s : word;
     t     : longint;
begin
  t:= Get_TimeFromStart;
  if Abs(t - OldTime) >= CSecond then  begin
    OldTime:= t;
    t:= t + StartTime;
    asm
        PUSHF
        CLI
    end;
    t:= t div CSecond;      {s}
    s:= t mod 60;
    t:= t div 60;           {m}
    m:= t mod 60;
    t:= t div 60;           {h}
    h:= t mod 24;
    TimeStr := FormatTimeStr(h, m, s);
    asm  POPF  end;
    DrawView;
  end;
end;

function TClockView.FormatTimeStr(H, M, S: Word): String;
begin
  FormatTimeStr := LeadingZero(h)+ ':'+ LeadingZero(m) +
    ':' + LeadingZero(s);
end;

end.
